
#include <Firmata.h>

int incomingByte = 0;
int led = 9;

byte analogPin = 0;

void analogWriteCallback(byte pin, int value)
{
    if (IS_PIN_PWM(pin)) {
        pinMode(PIN_TO_DIGITAL(pin), OUTPUT);
        analogWrite(PIN_TO_PWM(pin), value);
    }
}

void setup()
{
  Serial.begin(9600);
  pinMode(led, OUTPUT);
  
    Firmata.setFirmwareVersion(0, 1);
    Firmata.attach(ANALOG_MESSAGE, analogWriteCallback);
    Firmata.begin(57600);
}

void loop()
{
  if (Serial.available() > 0) {
    incomingByte = Serial.read();
    
    analogWrite(led, incomingByte);
  }
    
    while(Firmata.available()) {
        Firmata.processInput();
    }
    Firmata.sendAnalog(analogPin, analogRead(analogPin)); 
    analogPin = analogPin + 1;
    if (analogPin >= TOTAL_ANALOG_PINS) analogPin = 0;
}

